package parser;

import java.util.Vector;
import java.util.Enumeration;
import tool.Locale;

public class VariableNode implements Node {

 private char name;

 protected VariableNode(char name) {
  this.name = name;
 }

 public double getValue(Vector variables) {
  Enumeration enum = variables.elements();
  while ( enum.hasMoreElements() ) {
   Variable v = (Variable)enum.nextElement();
   if ( v.getName() == name ) {
    return v.getValue();
   }
  }
  throw new RuntimeException(Locale.UndefinedVar+ name);
 }

}
