package tool;

import parser.*;
import java.util.*;

public class Utils {
 public static String []arr;
 private static double e = 2.71828182845904524;
 private static Variable v = new Variable('Y');
 private static Function f = new Function();
 private static Vector vec = new Vector();

 public static String strDelSpc(String s) {
  String s1 = "";
  for (int i=0; i<s.length(); i++)
   if (s.charAt(i) != ' ') s1 = s1 + String.valueOf(s.charAt(i));
  return s1;
 }

 public static void strSplitOf(String s, char c) {
  if (s.length() == 0) {
   arr = new String[0];
   return;
  }
  if (s.charAt(s.length()-1) != c) s = s + c;
  //Count
  int i, k, count = 0;
  for (i=0; i<s.length(); i++)
   if(s.charAt(i) == c) count++;
  //Split
  String ss = String.valueOf(c);
  arr = new String[count];
  count = 0;
  k = s.indexOf(ss);
  while (k >= 0) {
   arr[count] = s.substring(0, k);
   s = s.substring(k+1);
   k = s.indexOf(ss);
   count++;
  }
 }

 public static String strReplace(String s, String olds, String news) {
  int k = s.indexOf(olds);
  while (k >= 0) {
   if (k > 0) s = s.substring(0, k) + news + s.substring(k+olds.length());
   else s = news + s.substring(k+olds.length());
   k = s.indexOf(olds);
  }
  return s;
 }

 public static double round(double a) {
  if (a - Math.floor(a) < Math.ceil(a) - a) return Math.floor(a);
  else return Math.ceil(a);
 }

 public static double exp(double x) {
  if (Math.abs(x)>706) return 1/0;  
  double l=1.0;
  double xn=x;
  double nf=1;
  int i;
  for (i=1; i<51; i++) {
   l+=xn/nf;
   xn*=x;
   nf*=(i+1);
  }
  return l;
 }

 public static double ln (double x) {
  if (x<=0) return 1/0;
  double a,b;
  if (x>1) {
   a=0;
   while (x>1) {
    x/=10;
    a++;
   }
   b=x;
  }
  else {
   b=x; a=0.0;
  }
  //System.out.println (a+","+b);
  int s=1;
  double l=0.0;
  b-=1.0;
  double xn=b;
  double n=1.0;
  int i;
  for (i=1; i<51; i++) {
   l+=s*xn/n;
   s=-s;
   xn*=b;
   n=(double)(i+1);
  }
  return l+a*2.302585092994046;
 }

 public static double pow(double a, double b) {
  //System.out.print (""+a+","+b);
  if (Math.abs(b)>100) return 1/0;
  if (Math.abs(a)<1E-9) return 0;
  if (Math.abs(b)<1E-9) return 1;
  if (Math.abs(b-1)<1E-9) return a;
  double c;
  if (a>0) c=exp(b*ln(a));
  else {
   double bl=round(b);
   if (Math.abs(bl-b)<1E-9) { // 
    int bi=(new Double(bl)).intValue();
    c=exp(bi*ln(Math.abs(a)));
    if (bi%2!=0) c=-c;
   }
   else {
    return 1/0;
   }
  }
  //System.out.println (","+c);
  return c;
 }

 public static double trunc(double a) {
  return round(a*1000)/1000;
 }

 public static void prepareVal(char c, String exp) {
  v.setName(c);
  vec.removeAllElements();
  vec.addElement(v);
  f.initialize(exp);
 }

 public static double Cal(double a) {
  v.setValue(a);
  return f.calculate(vec);
 }

}
